//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TeachingClock0.h"
#include <mmSystem.h>      // for PalySound(.)
#include <math.h>
#include <DateUtils.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void toGray(TImage *image)
{ Byte * ptr;
  int r, g, b, gray, index;

  image->Picture->Bitmap->PixelFormat = pf24bit;
  for (int row=0; row<image->Picture->Height; row++)
     { ptr = (Byte*) image->Picture->Bitmap->ScanLine[row];
       index = 0;
       for (int col=0; col<image->Picture->Width; col++)
          { b = ptr[index  ];
            g = ptr[index+1];
            r = ptr[index+2];
            gray = 0.299*r + 0.587*g + 0.114*b;
            ptr[index  ] = (Byte)gray;
            ptr[index+1] = (Byte)gray;
            ptr[index+2] = (Byte)gray;
            index += 3;
          }
     }
}
void to2D(TImage *image)
{ Byte **ptr;
  int r, g, b, gray, index;

  image->Picture->Bitmap->PixelFormat = pf24bit;
  ptr = new Byte*[image->Picture->Height];
  for (int k=0; k<image->Picture->Height; k++)
     ptr[k] = (Byte*) image->Picture->Bitmap->ScanLine[k];
  for (int row=0; row<image->Picture->Height; row++)
     { index = 0;
       for (int col=0; col<image->Picture->Width; col++)
          { b = ptr[row][index  ];
            g = ptr[row][index+1];
            r = ptr[row][index+2];
            gray = 0.299*r + 0.587*g + 0.114*b;
            ptr[row][index  ] = (Byte)gray;
            ptr[row][index+1] = (Byte)gray;
            ptr[row][index+2] = (Byte)gray;
            index += 3;
          }
     }
  delete [] ptr;
}
void JpgToBmp(TImage *image)
{ Graphics::TBitmap *bmp = new Graphics::TBitmap();

  bmp->Width  = image->Picture->Width;
  bmp->Height = image->Picture->Height;
  bmp->Canvas->Draw(0,0,image->Picture->Graphic);
  image->Picture->Bitmap->Assign(bmp);
  image->Refresh();

  delete bmp;
}
void shrink(Graphics::TBitmap *bmp, float sx, float sy)
{ int x, y, px, py, bkx, bky, h, w;
  int mWidth, mHeight;
  unsigned long index;
  float value;
  BYTE *ptr, *pImg;
  Graphics::TBitmap *mBmp = new Graphics::TBitmap();

  mBmp->Assign(bmp);  // ƥ
  mBmp->PixelFormat = pf24bit;
  
  w = mBmp->Width * sx;  // pYϤؤo
  h = mBmp->Height* sy;
  bmp->Width  = w;
  bmp->Height = h;
  bmp->PixelFormat = pf24bit;

  mWidth  = mBmp->Width;
  mHeight = mBmp->Height;
  
  sx = 1.0/sx;  sy = 1.0/sy;
  unsigned long idxImg=0L;
  int gray[3];
  for (py=0; py<h; py++)
     { pImg = (Byte *) bmp->ScanLine[py];
       for (px=0; px<w; px++)
  	  { x = px*sx;
            y = py*sy;
            idxImg = y*mWidth+x;

            gray[0]=gray[1]=gray[2]=0;
            for (bky=0; bky<sy; bky++)  // o϶C⪺
               { ptr = (Byte *) mBmp->ScanLine[y+bky];
                 for (bkx=0; bkx<sx; bkx++)
                    { gray[0] += ptr[3*(x+bkx)  ];
                      gray[1] += ptr[3*(x+bkx)+1];
                      gray[2] += ptr[3*(x+bkx)+2];
                    }
               }
            for (int k=0; k<3; k++) gray[k] /= (bkx*bky);
            pImg[3*px  ] = gray[0];
            pImg[3*px+1] = gray[1];
            pImg[3*px+2] = gray[2];
  	  }
     }
}
void stretch(Graphics::TBitmap *bmp, float sx, float sy)
{ float a,b,c,d,p,q,r,s,dx,dy;
  int x, y, nX, nY, nH, nW, z;
  float value, *image=NULL, *buffer=NULL;
  int mWidth, mHeight;
  unsigned long index;
  BYTE *ptr, *ptr1, *pImg;
  Graphics::TBitmap *mBmp = new Graphics::TBitmap();

  mBmp->Assign(bmp);  // ƥ
  mBmp->PixelFormat = pf24bit;  // carefully set the property to correctly read data.
  bmp->PixelFormat  = pf24bit;
  bmp->Width  = mBmp->Width *sx+1;
  bmp->Height = mBmp->Height*sy+1;

  mWidth  = mBmp->Width;
  mHeight = mBmp->Height;
  nW = sx*mWidth; nH = sy*mHeight;

  unsigned long idxImg=0L;
  for (nY=0; nY<nH-1; ++nY)
     { pImg = (Byte *) bmp->ScanLine[nY];
       for (nX=0; nX<nW-1; ++nX)
	  { value = nX/sx;
            x = int(value); dx = value-x;
            value = nY/sy;
            y = int(value); dy = value-y;

            //if ( y>=mHeight-1 ) ShowMessage("y is too large.");
            if ( y>mHeight-1 ) ShowMessage("y is too large."); // modified on 2004.4.7.

            if ( x>=mWidth-1 ) x=mWidth-2;
            x *= 3;  // color image
            if ( y>=mHeight-1 ) y=mHeight-2;
            ptr  = (BYTE *) mBmp->ScanLine[y  ];
            ptr1 = (BYTE *) mBmp->ScanLine[y+1];
            for (int c=0; c<3; c++)
               { p = ptr [c+x+3] - ptr [c+x  ];
                 q = ptr [c+x  ] + ptr1[c+x+3] -
                     ptr [c+x+3] - ptr1[c+x  ];
                 r = ptr1[c+x] - ptr[c+x];
                 s = ptr [c+x];
                 pImg[nX*3+c] = p*dx+q*dx*dy+r*dy+s;
               }

	  }
       idxImg += nW;
     }

  delete mBmp;
}
const double Deg2Rad = 3.141592653/180.;

enum TextPosition { LEFTUP=1,   UP,     RIGHTUP,
                    LEFT,       CENTER, RIGHT,
                    LEFTBOTTOM, BOTTOM, RIGHTBOTTOM,
                    USERDEFINE };

void putText(TCanvas *canvas, int x, int y, char *text,
             TextPosition tp=LEFTUP, int xc=0, int yc=0)
{ int h, w;
  TBrushStyle oldBrushStyle;
  h=canvas->TextHeight(text);
  w=canvas->TextWidth(text);
  switch(tp)
    { case      LEFTUP : x-=w;      y-=h;      break;
      case          UP : x-=(w>>1); y-=h;      break;
      case     RIGHTUP :            y-=h;      break;
      case        LEFT : x-=w;      y-=(h>>1); break;
      case      CENTER : x-=(w>>1); y-=(h>>1); break;
      case       RIGHT :            y-=(h>>1); break;
      case  LEFTBOTTOM : x-=w;                 break;
      case      BOTTOM : x-=(w>>1);            break;
      case RIGHTBOTTOM : break;
      case  USERDEFINE : x-=xc;     y-=yc;
    };
  oldBrushStyle=canvas->Brush->Style;
  canvas->Brush->Style=bsClear;  //
  canvas->TextOut(x, y, text);
  canvas->Brush->Style=oldBrushStyle;

}
// (xc, yc) : the center of rotating text
// (x0, y0) : the relative position to (xc, yc), also assigned by tp.
// It's available for truetype fonts only !!!
void rotateText(TCanvas *canvas, int xc, int yc, char *text,
                TextPosition tp=LEFTUP, int angle=0, int x0=0, int y0=0)
{ int h, w, xn, yn;
  float cosine, sine;
  TLogFont lf;
  TBrushStyle oldBrushStyle;

  GetObject(canvas->Font->Handle, sizeof(TLogFont), &lf);

  h=canvas->TextHeight(text);
  w=canvas->TextWidth(text);
  switch(tp)
    { case      LEFTUP : x0=xc;        y0=yc;        break;
      case          UP : x0=xc-(w>>1); y0=yc;        break;
      case     RIGHTUP : x0=xc-w;      y0=yc;        break;
      case        LEFT : x0=xc;        y0=yc-(h>>1); break;
      case      CENTER : x0=xc-(w>>1); y0=yc-(h>>1); break;
      case       RIGHT : x0=xc-w;      y0=yc-(h>>1); break;
      case  LEFTBOTTOM : x0=xc;        y0=yc-h;      break;
      case      BOTTOM : x0=xc-(w>>1); y0=yc-h;      break;
      case RIGHTBOTTOM : x0=xc-w;      y0=yc-h;      break;
      case  USERDEFINE : x0=xc-x0;     y0=yc-y0;     break; //case of user defines (xc, yc)
    };
  oldBrushStyle=canvas->Brush->Style;
  canvas->Brush->Style=bsClear;  //
  cosine=cos(angle*Deg2Rad);  sine=sin(angle*Deg2Rad);
  xn= xc + (x0-xc)*cosine + (y0-yc)*sine;
  yn= yc - (x0-xc)*sine   + (y0-yc)*cosine;

  lf.lfEscapement=(angle)*10;
  /*
  lf.lfHeight=h;
  lf.lfWidth =0;
  lf.lfWeight = FW_NORMAL;
  lf.lfCharSet = DEFAULT_CHARSET;
  lf.lfOutPrecision = OUT_DEFAULT_PRECIS;
  lf.lfClipPrecision = CLIP_DEFAULT_PRECIS;
  lf.lfQuality = DEFAULT_QUALITY;
  lf.lfPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
  */
  canvas->Font->Handle=CreateFontIndirect(&lf);
  canvas->TextOut(xn, yn, text);

  canvas->Brush->Style=oldBrushStyle;
}

float clockW=200., clockH=200.;
int hourStep=30, minStep=6, secStep=6;
int hourHand = (int) (clockW/2*0.70),
    minHand  = (int) (clockW/2*0.85),
    secHand  = (int) (clockW/2*0.90);
WORD year, month, day;
int  hour, minute, second, msecond;
bool setTime=false, manualChanging=false, quizzing=false;
TDateTime now;
AnsiString msg;
int peakY = 190;
TPoint points[4] = {
  Point(5,peakY-5),
  Point(1,peakY),
  Point(9,peakY),
  Point(5,peakY+5)
};

void drawClock(TCanvas *showCanvas)
{ int x0=100, y0=100;
  double angle;
  TRect rect;
  TCanvas *canvas = Form1->Image2->Picture->Bitmap->Canvas;
  if ( Form1->Timer1->Enabled )
    { now = Now();
      WORD h,m,s,ms;
      DecodeDateTime(now, year, month, day, h, m, s, ms);
      hour   = (int) h;
      minute = (int) m;
      second = (int) s;
      msecond= (int)ms;
    }
  else if ( setTime ) // for testing
    { hour   = Form1->udHour->Position;
      minute = Form1->udMin->Position;
      second = 0;
    }
  else if ( manualChanging )
    { //minute = Form1->udMin->Position;
      second = 0;
    }
  
  if ( Form1->chkBoxImage->Checked )
    { canvas->CopyRect(Rect(0,0,clockW,clockH), Form1->Image1->Canvas, Form1->Image1->ClientRect);
    }
  else
    { canvas->Rectangle(-1,-1,clockW+1,clockH+1);
    }
  // draw numbers or ticks
  canvas->Font = Form1->FontDialog1->Font;
  int x,y,radius;
  if ( Form1->chkBoxTick->Checked )
    { canvas->Pen->Width = 1;
      for (int k=1; k<=14; k++)
         { angle =(90-k*secStep)*Deg2Rad;
           x = (secHand+3)*cos(angle);
           y = (secHand+3)*sin(angle);
           if ( 0 == (k%5) )
             { canvas->Pen->Color = clRed;
               radius=2;
             }
           else
             { canvas->Pen->Color = clBlue;
               radius=1;
             }
           canvas->Ellipse(x0+x-radius, y0+y-radius, x0+x+radius, y0+y+radius);
           canvas->Ellipse(x0-x-radius, y0+y-radius, x0-x+radius, y0+y+radius);
           canvas->Ellipse(x0-x-radius, y0-y-radius, x0-x+radius, y0-y+radius);
           canvas->Ellipse(x0+x-radius, y0-y-radius, x0+x+radius, y0-y+radius);
         }

      canvas->Pen->Color = clRed;
      canvas->Pen->Width = 2;
      radius = 3;
      x=0; y=(secHand+3);
      canvas->Ellipse(x0-x-radius, y0-y-radius, x0-x+radius, y0-y+radius);
      canvas->Ellipse(x0-x-radius, y0+y-radius, x0-x+radius, y0+y+radius);
      x=(secHand+3); y=0;
      canvas->Ellipse(x0-x-radius, y0-y-radius, x0-x+radius, y0-y+radius);
      canvas->Ellipse(x0+x-radius, y0+y-radius, x0+x+radius, y0+y+radius);
    }
  else
    { radius = 1;
      canvas->Pen->Color = clBlack;
      canvas->Pen->Width = 1;
      for (int k=1; k<=14; k++)
         { angle =(90-k*minStep)*Deg2Rad;
           x = (secHand+3)*cos(angle);
           y = (secHand+3)*sin(angle);
           if ( 0 == (k%5) ) continue;
           canvas->Ellipse(x0+x-radius, y0+y-radius, x0+x+radius, y0+y+radius);
           canvas->Ellipse(x0-x-radius, y0+y-radius, x0-x+radius, y0+y+radius);
           canvas->Ellipse(x0-x-radius, y0-y-radius, x0-x+radius, y0-y+radius);
           canvas->Ellipse(x0+x-radius, y0-y-radius, x0+x+radius, y0-y+radius);
         }
      for (int k=1; k<=6; k++)
         { angle =(90-k*hourStep)*Deg2Rad;
           x = (secHand+3)*cos(angle);
           y = (secHand+3)*sin(angle);
           putText(canvas, x0+x, y0-y, IntToStr(k).c_str(), CENTER);
           putText(canvas, x0-x, y0+y, IntToStr(k+6).c_str(), CENTER);
         }
    }

  if ( Form1->chkBoxImage->Checked )
    canvas->Pen->Mode = pmNot;
  //===== draw second Hand
  if ( Form1->Timer1->Enabled )
    { angle = (90-second*secStep) * Deg2Rad;
      if ( Form1->SecondHand1->Checked || Form1->chkBoxImage->Checked )
        { canvas->Pen->Width = 1;
          canvas->Pen->Color = clGray;
          canvas->MoveTo(x0, y0);
          canvas->LineTo(x0+secHand*cos(angle), y0-secHand*sin(angle));
        }
      // =====
      if ( Form1->SmallClock1->Checked && (! Form1->chkBoxImage->Checked) )
        { int xp=140, yp=135, sr=25;

          canvas->Pen->Width = 1;
          canvas->Pen->Color = clBlack;
          canvas->MoveTo(xp, yp);
          canvas->LineTo(xp+sr*cos(angle), yp-sr*sin(angle));
          for (int k=0; k<=15; k++)
             { angle =(90-k*secStep)*Deg2Rad;
               x = sr*cos(angle);
               y = sr*sin(angle);
               if ( 0 == (k%5) )
                 { canvas->Pen->Color = clRed; radius=2; }
               else { canvas->Pen->Color = clBlack; radius=1; }
               canvas->Ellipse(xp+x-radius, yp+y-radius, xp+x+radius, yp+y+radius);
               canvas->Ellipse(xp-x-radius, yp+y-radius, xp-x+radius, yp+y+radius);
               canvas->Ellipse(xp-x-radius, yp-y-radius, xp-x+radius, yp-y+radius);
               canvas->Ellipse(xp+x-radius, yp-y-radius, xp+x+radius, yp-y+radius);
             }
        }
      // =====
    }
  //===== draw minute Hand
  canvas->Pen->Width = 3;
  canvas->Pen->Color = clBlue;
  angle = (90-(minute+second/60.)*minStep) * Deg2Rad;
  canvas->MoveTo(x0, y0);
  canvas->LineTo(x0+minHand*cos(angle), y0-minHand*sin(angle));

  //===== draw hour Hand
  canvas->Pen->Width = 3;
  canvas->Pen->Color = clRed;
  angle = (90-(hour+minute/60.)*hourStep) * Deg2Rad;
  canvas->MoveTo(x0, y0);
  canvas->LineTo(x0+hourHand*cos(angle), y0-hourHand*sin(angle));

  Form1->Label1->Caption = DateTimeToStr(now);

  canvas->Pen->Mode  = pmCopy;
  canvas->Font = Form1->FontDialog1->Font;
  if ( (!quizzing) && Form1->ComboBox1->ItemIndex!=Form1->ComboBox1->Items->Count-1 )
    { if ( Form1->N24Hours1->Checked )
        { msg.printf("%2d : %02d", hour, minute);
          //canvas->Font->Color = clBlue;
          canvas->Brush->Style = bsClear;
          canvas->TextOutA(3, clockH-canvas->TextHeight("H")-3, msg.c_str());
          canvas->Brush->Style = bsSolid;
        }
      else
        { canvas->Font->Size  = 9;
          //canvas->Font->Color = clBlue;

          if ( hour>=12 )
            { canvas->Brush->Style = bsSolid;
              canvas->Brush->Color = clRed;
              canvas->Pen->Width = 1;
              canvas->Polygon(&points[1], 2);
              canvas->Brush->Style = bsClear;
              canvas->TextOutA(3, clockH-canvas->TextHeight("H")*2-2, "U");
            }
          else
            { canvas->Brush->Style = bsSolid;
              canvas->Brush->Color = clRed;
              canvas->Pen->Width = 1;
              canvas->Polygon(&points[0], 2);
              canvas->Brush->Style = bsClear;
              canvas->TextOutA(3, clockH-canvas->TextHeight("H")*2-2, "W");
            }
          canvas->Brush->Style = bsClear;
          msg.printf("%2d : %02d", hour%12, minute);
          canvas->TextOutA(10, clockH-canvas->TextHeight("H")-3, msg.c_str());
          canvas->Brush->Style = bsSolid;
        }
    }
  canvas->Font->Color = Form1->FontDialog1->Font->Color;
  canvas->Pen->Color  = clWhite;
  showCanvas->CopyRect(Rect(0,0,clockW,clockH), canvas, Rect(0,0,clockW,clockH));
}

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  drawClock(Form1->Canvas);
  //drawClock(Image1->Canvas);
}
//---------------------------------------------------------------------------
void TForm1::setSwitch()
{ if ( Timer1->Enabled )
    { bitnStartTimer->Font->Color = clGreen;
      bitnStartTimer->Caption = "Ȱp"; //"Stop Timer";
    }
  else
    { bitnStartTimer->Font->Color = clRed;
      bitnStartTimer->Caption = "Ұʭp"; //"Start Timer";
    }
}

void __fastcall TForm1::bitnStartTimerClick(TObject *Sender)
{
  Timer1->Enabled = ! Timer1->Enabled;
  setSwitch();
  quizzing = false;
  ComboBox1->ItemIndex = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  DoubleBuffered = true;
  JpgToBmp(Image1);
  Image2->Picture->Assign(Image1->Picture);
  float sx = clockW / Image1->Picture->Width;
  float sy = clockH /Image1->Picture->Height;
  shrink(Image1->Picture->Bitmap, sx, sy);
  udHour->Wrap = true;
  udMin->Wrap  = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Load1Click(TObject *Sender)
{
  if ( OpenDialog1->Execute() )
    { Image1->Picture->LoadFromFile(OpenDialog1->FileName);
      Image1->Top  = 1;
      Image1->Left = 1;
      Graphics::TBitmap *bmp = new Graphics::TBitmap();
      bmp->Width  = Image1->Picture->Width;
      bmp->Height = Image1->Picture->Height;
      bmp->Canvas->Draw(0,0,Image1->Picture->Graphic);
      //
      float sx = clockW / bmp->Width;
      float sy = clockH / bmp->Height;
      //shrink(bmp, sx, sy);
      stretch(bmp, sx, sy);
      //
      Image1->Picture->Bitmap->Assign(bmp);
      Image1->Refresh();
      delete bmp;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClockFont1Click(TObject *Sender)
{
  FontDialog1->Execute();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::bitnSetTimeClick(TObject *Sender)
{
  setTime = true;
  drawClock(Form1->Canvas);
  setTime = false;
  //udHour->Position =  6;
  //udMin->Position  = 30;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::bitnReadClockClick(TObject *Sender)
{
  if ( (hour==udHour->Position) && (minute==udMin->Position) )
    { PlaySound("./tada.wav", NULL, SND_ASYNC);
      lbResult->Caption = "zFI" ;
      lbResult->Refresh();
      //ShowMessage("zFI");
      quizzing = false;
    }
  else if ( hour != udHour->Position )
    { PlaySound("./chimes.wav", NULL, SND_ASYNC);
      lbResult->Caption = "IƤI";
      lbResult->Refresh();
      //ShowMessage("IƤIAդ@I");
    }
  else if ( minute != udMin->Position )
    { PlaySound("./chimes.wav", NULL, SND_ASYNC);
      lbResult->Caption = "ƤI";
      lbResult->Refresh();
      //ShowMessage("ƤIAդ@I");
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
  if ( ComboBox1->ItemIndex==-1 )
    ComboBox1->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::bitnTestClick(TObject *Sender)
{
  int type = ComboBox1->ItemIndex;
  if ( type==-1 ) type = 0;
  hour = random(12)+1;
  second = 0;
  switch( type )
    { case 0: minute =  0;  udMin->Position =  0;
              break;
      case 1: minute = 30;  udMin->Position = 30;
              break;
      case 2: minute = random(12)*5;
              break;
      case 3: minute = random(60);
    }
  Timer1->Enabled = false;
  setSwitch();
  quizzing = true;
  drawClock(Form1->Canvas);

  PlaySound("./ding.wav", NULL, SND_ASYNC);
  lbResult->Caption = "Ч@I";
}
//---------------------------------------------------------------------------
bool pressing = false;
int prevX, prevY;

void __fastcall TForm1::pnlTuningClockMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if ( Timer1->Enabled )
    { ShowMessage("Х'Ȱp'I");
    }
  else
    { pressing = true;
      prevY = Y;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::pnlTuningClockMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{ int min, hr, dy;
  if ( pressing )
    { dy = Y - prevY;
      prevY = Y;

      if ( minute+dy<0 )
        { minute += dy+60;
          hour--;
          if ( hour<1 ) hour = 12;
        }
      else if ( minute+dy>59 )
        { minute -= 60;
          hour++;
          if ( hour>12 ) hour = 1;
        }
      else minute += dy;

      //udHour->Position = hour;
      //udMin->Position  = minute;

      manualChanging = true;
      drawClock(Form1->Canvas);
      manualChanging = false;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::pnlTuningClockMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
  pressing = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormPaint(TObject *Sender)
{
  drawClock(Form1->Canvas);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Clock1Click(TObject *Sender)
{
   GroupBox1->Visible      = false;
   pnlTuningClock->Visible = false;
   Form1->ClientWidth = 201;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::All1Click(TObject *Sender)
{
  GroupBox1->Visible      = true;
  pnlTuningClock->Visible = true;
  Form1->ClientWidth = 438;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SmallClock1Click(TObject *Sender)
{
  SmallClock1->Checked = ! SmallClock1->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SecondHand1Click(TObject *Sender)
{
  SecondHand1->Checked = ! SecondHand1->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N24Hours1Click(TObject *Sender)
{
  N24Hours1->Checked = ! N24Hours1->Checked;
}
//---------------------------------------------------------------------------

